﻿using System.Collections.Generic;
using System.Linq;
using DKX.Pg.AOT.CodeBuilder;
using DKX.Pg.AOT.Entities;
using DKX.Pg.AOT.Exceptions;
using DKX.Pg.AOT.Metadata;
using Microsoft.CodeAnalysis;
using Microsoft.CodeAnalysis.CSharp;
using Microsoft.CodeAnalysis.CSharp.Syntax;

namespace DKX.Pg.AOT.Generators
{
	[Generator]
	public sealed class EntityGenerator : ISourceGenerator
	{
		public void Initialize(GeneratorInitializationContext context)
		{
			context.RegisterForSyntaxNotifications(() => new SyntaxReceiver());
		}

		public void Execute(GeneratorExecutionContext context)
		{
			if (!(context.SyntaxReceiver is SyntaxReceiver syntaxReceiver))
			{
				return;
			}

			var models = new Dictionary<SyntaxTree, SemanticModel>();

			var i = 0;
			foreach (var type in syntaxReceiver.Entities)
			{
				if (!models.TryGetValue(type.SyntaxTree, out var model))
				{
					model = context.Compilation.GetSemanticModel(type.SyntaxTree);
					models.Add(type.SyntaxTree, model);
				}
				
				var hasEntityAttribute = type.AttributeLists
					.SelectMany(l => l.Attributes)
					.Any(a => model.GetTypeInfo(a).Type?.ToString() == "DKX.Pg.Entities.EntityAttribute");

				if (!hasEntityAttribute)
				{
					continue;
				}

				try
				{
					var entity = type.ToEntityMetadata(model);
					var file = GenerateFile(entity);
					context.AddSource($"{entity.Name}.Generated{i++}.cs", file.ToSourceText());
				}
				catch (DiagnosticsAwareException e)
				{
					context.ReportDiagnostic(e.ToDiagnostic());
				}
			}
		}

		private static FileBuilder GenerateFile(EntityMetadata entity)
		{
			var file = new FileBuilder();
			file.Add("#nullable enable");
			file.Add("");
			file.Add("//------------------------------------------------------------------------------");
			file.Add("// <auto-generated>");
			file.Add("// This code was generated by:");
			file.Add("//     DKX.Pg.AOT.Generators.EntityGenerator");
			file.Add("// Changes to this file may cause incorrect behavior and");
			file.Add("// will be lost if the code is regenerated.");
			file.Add("// </auto-generated>");
			file.Add("//------------------------------------------------------------------------------");
			file.Add("");

			var ns = new NamespaceBuilder(entity.ContainingNamespace);
			ns.Add(GenerateEntity(entity));
			ns.Add("");
			ns.Add(GenerateEntityMetadata(entity));

			file.Add(ns);

			return file;
		}

		private static ClassBuilder GenerateEntity(EntityMetadata entity)
		{
			var cls = new ClassBuilder(entity.Kind, entity.Name);
			cls.AddModifier("public");
			cls.AddModifier("partial");

			var ctor = new ConstructorBuilder(entity.Name);
			ctor.AddParameter("global::System.Data.IDataRecord", "record");
			ctor.AddParameter("int[]", "mapping");
			cls.Add(ctor);
				
			for (var i = 0; i < entity.Properties.Length; i++)
			{
				var writeProperty = entity.Properties[i];
				var maybeNull = writeProperty.TypeInfo.IsNullable ? $"record.IsDBNull(mapping[{i}]) ? ({writeProperty.TypeInfo.FullName}?)null : " : "";
				var cast = writeProperty.TypeInfo.MustUnbox ? $"({writeProperty.TypeInfo.FullName})" : "";

				ctor.Add($"{writeProperty.Name} = {maybeNull}{cast}record.{writeProperty.TypeInfo.DataRecordGetter}(mapping[{i}]);");
			}

			return cls;
		}

		private static ClassBuilder GenerateEntityMetadata(EntityMetadata entity)
		{
			var cls = new ClassBuilder(ClassKind.Class, $"{entity.Name}EntityMetadata");
			cls.AddModifier("public");
			cls.AddModifier("sealed");
			cls.AddExtendOrImplement($"global::DKX.Pg.Metadata.IEntityMetadata<{entity.Name}>");

			var properties = new PropertyBuilder($"global::DKX.Pg.Metadata.IPropertyMetadata<{entity.Name}>[]", "Properties");
			properties.AddModifier("public");
			
			var propertiesArray = new ArrayBuilder($"global::DKX.Pg.Metadata.IPropertyMetadata<{entity.Name}>");
			foreach (var property in entity.Properties)
			{
				propertiesArray.Add($"new global::DKX.Pg.Metadata.PropertyMetadata<{entity.Name}>(\"{property.Name}\", \"{property.DatabaseName}\", {(property.IsIdentifier ? "true" : "false")}, {(property.IsGenerated ? "true" : "false")}, entity => entity.{property.Name}),");
			}

			properties.SetValue(propertiesArray);
			cls.Add(properties);
			cls.Add("");

			var createMappingMethod = new MethodBuilder("CreateMapping", "int[]");
			createMappingMethod.AddParameter("global::System.Data.IDataRecord", "record");

			var mappingArray = new ArrayBuilder("int");
			foreach (var property in entity.Properties)
			{
				mappingArray.Add($"record.GetOrdinal(\"{property.DatabaseName}\"),");
			}
			
			createMappingMethod.Add(new ReturnBuilder(mappingArray));
			cls.Add(createMappingMethod);
			cls.Add("");

			var createEntityMethod = new MethodBuilder("CreateEntity", entity.Name);
			createEntityMethod.AddParameter("global::System.Data.IDataRecord", "record");
			createEntityMethod.AddParameter("int[]", "mapping");
			createEntityMethod.Add($"return new {entity.Name}(record, mapping);");
			cls.Add(createEntityMethod);

			return cls;
		}

		private sealed class SyntaxReceiver : ISyntaxReceiver
		{
			public readonly IList<IEntitySyntaxType> Entities = new List<IEntitySyntaxType>();

			public void OnVisitSyntaxNode(SyntaxNode syntaxNode)
			{
				if (syntaxNode is ClassDeclarationSyntax cds && cds.AttributeLists.Sum(l => l.Attributes.Count) > 0)
				{
					Entities.Add(new ClassEntitySyntaxType(cds));
				}

				if (syntaxNode is RecordDeclarationSyntax rds && rds.AttributeLists.Sum(l => l.Attributes.Count) > 0)
				{
					Entities.Add(new RecordEntitySyntaxType(rds));
				}
			}
		}
	}
}
